//*****************************************
// IV-18 VFD Clock Program Mega328
// CPU Clock:8MHz
//   iq[Yf[^@UWlgɂj
// File Name:Ad_conv.c
//
//  PC1(ADC1): CdS
//
//  2015/12/29 New
//*****************************************
#include				<avr/io.h>

#include				"iv18_clock.h"
#include				"Ad_conv.h"

unsigned short	ad1_data[N_of_AD_data];
unsigned char	ad1_count;
unsigned char	ad_conv_1;									// 1:ADC1 Convert running
// **********************************************************
// ************************** A/D 1 *************************
// **********************************************************

//*****************************************
// A/D 1 Initial
// @荞ݕs̏ԂŌĂ΂Ƃ
//  PA1(ADC1): CdS (Full Volt = VCC)
//*****************************************
void	ad1_init(void)
{
	unsigned char	i;

	ad1_count = 0;
	for(i = 0; i < N_of_AD_data; i++){
		ad1_data[i] = 0;
	}


	PRR &= ~(1 << PRADC);																	// ADCғ
	DIDR0 |= (1 << ADC1D);																	// AiO͐ݒ PC1

	ADMUX = ( (0 << REFS1) | (1 << REFS0) | (0 << MUX3) | (0 << MUX2) | (0 << MUX1) | (1 << MUX0) );		// ubbdgp, Select ADC1
	ADCSRA = ( (1 << ADEN) | (1 << ADSC) | (1 << ADPS2) | (1 << ADPS1) | (1 << ADPS0) );	// A/D, A/DϊJn, CK/128=8MHz/128=62.5kHz(16uS) --> 208uS
	ad_conv_1 = 1;																			// 1:ADC7 Convert running

}
//*****************************************
// A/D 1 close
//*****************************************
void	ad1_close(void)
{
	ADCSRA = 0;																				// A/Ds
	ad_conv_1 = 0;																			// 0:ADC1 Convert Not running
}
//*****************************************
// A/D 1 Set A/D data to Data Buffer
//  ϊIĂȂ́@Ȃ
//*****************************************
void	ad1_set_data(void)
{
	if( (ADCSRA & (1 << ADIF)) != 0){								// `^cϊ
		ADCSRA |= (1 << ADIF);										// `^cϊtO폜
		if( ad_conv_1 != 0){										// ADC1 ϊ
			ad1_data[ad1_count] = ADCW;
			ad1_count++;
			ad1_count &= (N_of_AD_data - 1);
			ADMUX &= ( (1 << REFS1) | (1 << REFS0) );				// dwrbg͎c
			ADMUX |= ( (0 << MUX2) | (0 << MUX1) | (1 << MUX0) );	// Select ADC6
		}

		ADCSRA |= (1 << ADSC);										// A/DϊJn
	}
}
//*****************************************
// A/D 1 Get A/D data
//  obt@ɓĂf[^𕽋ςĎ擾
//*****************************************
unsigned short	ad1_get_data(void)
{
	unsigned char	i;
	unsigned short	sum;

	sum = 0;
	for(i = 0; i < N_of_AD_data; i++){						// obt@Sđ
		sum += ad1_data[i];
	}

	sum /= N_of_AD_data;									// f[^Ŋĕϒlɂ

	return(sum);
}
