//*****************************************
// IV-18 VFD Clock Program Mega328
// CPU Clock:8MHz
//   iq[Yf[^@UWlgɂj
//
// 2015/12/29
//  qsbQṼ\[X𗬗pāAVZOf[^ƌύXĂhu|PWpƂ
//
//  2015/12/29 New(TAB4)  Taishi
//  2016/02/09 modify     Taishi  vݒ莞̒l̋ύX
//  2016/04/26 modify     Taishi  ɃAj[Vǉ
//  2016/04/28 modify     Taishi  \[hɁu[hvǉ
//*****************************************


#include	<avr/interrupt.h>
#include	<avr/io.h>
#include	<avr/pgmspace.h>
#include	<avr/sleep.h>
#include	<avr/eeprom.h>
#include	<stdio.h>

#include	"iv18_clock.h"
#include	"uart.h"
#include	"Timer.h"
#include	"disp_7seg_iv18.h"
#include	"Rtc_DS3234.h"
#include	"port_bit.h"
#include	"Ad_conv.h"
#include	"utl.h"
#include	"set_rtc.h"


// **********************************************************
// ******************** Save Data(EEPROM) *******************
// **********************************************************

unsigned char	eep_disp_mode EEMEM = 1;						// \[h PFglr@QFlcgl

unsigned char	num_data[KETA_MAX+1]={0x00,0x01,0x02,0x03,0x04,0x05,0x06,0x07,0x08,0};	// X̐f[^
unsigned char	dp_data[KETA_MAX+1] ={0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0};	// X̏_f[^

static	unsigned char	ani_num_data0[18][KETA_MAX+1]={
		{ '-',0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0},	// PԖڂX̐f[^
		{0x10, '-',0x10,0x10,0x10,0x10,0x10,0x10,0x10,0},	// QԖڂX̐f[^
		{0x10,0x10, '-',0x10,0x10,0x10,0x10,0x10,0x10,0},	// RԖڂX̐f[^
		{0x10,0x10,0x10, '-',0x10,0x10,0x10,0x10,0x10,0},	// SԖڂX̐f[^
		{0x10,0x10,0x10,0x10, '-',0x10,0x10,0x10,0x10,0},	// TԖڂX̐f[^
		{0x10,0x10,0x10,0x10,0x10, '-',0x10,0x10,0x10,0},	// UԖڂX̐f[^
		{0x10,0x10,0x10,0x10,0x10,0x10, '-',0x10,0x10,0},	// VԖڂX̐f[^
		{0x10,0x10,0x10,0x10,0x10,0x10,0x10, '-',0x10,0},	// WԖڂX̐f[^
		{0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10, '-',0},	// XԖڂX̐f[^
		{0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0},	// 10ԖڂX̐f[^
		{0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0},	// 11ԖڂX̐f[^
		{0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0},	// 12ԖڂX̐f[^
		{0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0},	// 13ԖڂX̐f[^
		{0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0},	// 14ԖڂX̐f[^
		{0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0},	// 15ԖڂX̐f[^
		{0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0},	// 16ԖڂX̐f[^
		{0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0},	// 17ԖڂX̐f[^
		{0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0},	// 18ԖڂX̐f[^
	};
static	unsigned char	ani_dot_data0[18][KETA_MAX+1]={
		{ 0,0,0,0,0,0,0,0,0,0},				// PԖڂX̏_f[^
		{ 0,0,0,0,0,0,0,0,0,0},				// QԖڂX̏_f[^
		{ 0,0,0,0,0,0,0,0,0,0},				// RԖڂX̏_f[^
		{ 0,0,0,0,0,0,0,0,0,0},				// SԖڂX̏_f[^
		{ 0,0,0,0,0,0,0,0,0,0},				// TԖڂX̏_f[^
		{ 0,0,0,0,0,0,0,0,0,0},				// UԖڂX̏_f[^
		{ 0,0,0,0,0,0,0,0,0,0},				// VԖڂX̏_f[^
		{ 0,0,0,0,0,0,0,0,0,0},				// WԖڂX̏_f[^
		{ 0,0,0,0,0,0,0,0,0,0},				// XԖڂX̏_f[^
		{ 0,0,0,0,0,0,0,0,1,0},				// 10ԖڂX̐f[^
		{ 0,0,0,0,0,0,0,1,0,0},				// 11ԖڂX̐f[^
		{ 0,0,0,0,0,0,1,0,0,0},				// 12ԖڂX̐f[^
		{ 0,0,0,0,0,1,0,0,0,0},				// 13ԖڂX̐f[^
		{ 0,0,0,0,1,0,0,0,0,0},				// 14ԖڂX̐f[^
		{ 0,0,0,1,0,0,0,0,0,0},				// 15ԖڂX̐f[^
		{ 0,0,1,0,0,0,0,0,0,0},				// 16ԖڂX̐f[^
		{ 0,1,0,0,0,0,0,0,0,0},				// 17ԖڂX̐f[^
		{ 1,0,0,0,0,0,0,0,0,0},				// 18ԖڂX̐f[^
	};

static	unsigned char	ani_seg_data1[7]={
		// D7;dp, D6:g, D5:f, D4:e, D3:d, D2:c, D1:b, D0:a
		0b00000001,				// PԖڃZOgf[^
		0b00000010,				// QԖڃZOgf[^
		0b00000100,				// RԖڃZOgf[^
		0b00001000,				// SԖڃZOgf[^
		0b00010000,				// TԖڃZOgf[^
		0b00100000,				// UԖڃZOgf[^
		0b00000001,				// VԖڃZOgf[^
	};

enum DISP_CLOCK_MODE {		// 샂[h
		HMS = 0,			// b\
		YMD,				// N\
		A_D,				// `^c\
		SET,				// v킹
		ANIME,				// Aj[V
		MDHM,				// \
		YEAR,				// N\
		A_D_MDHM			// `^c\i\j
	};

// **********************************************************
// ********************** Soft Timer ************************
// **********************************************************

volatile unsigned int	wait_i;
volatile unsigned int	wait_j;
volatile unsigned char	wait_us;
// ************************************
// Delay 2uS
// t: uS (max 255)
// CPU Clock:8.000MHz
//  while ߂ for ŎԂ킹Ă
// ************************************
void delay_2us(unsigned char t)
{
	unsigned char	i;

	for(i=0;i<t;i++){
		wait_us++;				// 1uS Delay??
		wait_us++;				// 1uS Delay??
		wait_us++;				// 1uS Delay??
	}
}
//***************************
// Wait
//  tm : Wait Time(ms) max. 8000
// CPU Clock:8.000MHz
//***************************
void	delay_ms(int tm)
{

	for(wait_i = 0; wait_i < tm; wait_i++){
		delay_2us(500/2);
		delay_2us(500/2);
	}
}
//***************************
// Aj[V\
//@ODTbɌĂ΂
// 
//@FP̂
// ߂l
//@OAj[Vr
//@PAj[VI
//***************************
unsigned char	disp_animation(unsigned char init)
{
	static	unsigned char	ani_count1 = 0;
	static	unsigned char	ani_count2 = 0;
	unsigned char			r = 0;
	if (init == 1){
		ani_count1 = 0;
		ani_count2 = 0;
	}else{
		if(ani_count1 == 0){
			chang_7seg_data(ani_num_data0[ani_count2],ani_dot_data0[ani_count2]);
			ani_count2++;
			if(18 <= ani_count2){							// 
				ani_count2 = 0;
				ani_count1++;								// ̃Aj
			}
		}else if(1 <= ani_count1){
			if(ani_count2 == 0){							// ŏ̎
				for(ani_count2=0;ani_count2 < KETA_MAX;ani_count2++){
					set_segmet_direct(0x00, ani_count2);
					set_7seg_dp(0, ani_count2);
				}
				ani_count2 = 0;
			}
			set_segmet_direct(ani_seg_data1[ani_count2], ani_count1);
			ani_count2++;
			if(7 <= ani_count2){							// ZOg
				ani_count2 = 0;
				ani_count1++;
				if(KETA_MAX <= ani_count1){
					ani_count1 = 0;
					r = 1;
				}
			}
		}
	}

	return(r);
}

// ݒs
unsigned char	set_pro(void)
{
	unsigned char	uc;
	unsigned char	se;
	unsigned char	bef_se;
	unsigned char	blk_stat=0;

	led_on_off(1);					// LED ON

	eeprom_busy_wait();
	se = eeprom_read_byte(&eep_disp_mode);		// Ǐo
	bef_se = se;

	delay_ms(500);					// 500mS Delay
	led_on_off(0);					// LED OFF
	delay_ms(500);					// 500mS Delay
	led_on_off(1);					// LED ON
	wait_sw_off();					// XCb`@܂ŉiv[v
	led_on_off(0);					// LED OFF

	sei();										// 荞݉

	set_7seg_data('-', 0, 7);		// '-'
	set_7seg_data('-', 0, 6);		// '-'
	set_segmet_direct(0x73, 5);		// 'P'
	set_7seg_data(5, 0, 4);			// 'S'
	set_segmet_direct(0x04, 3);		// 'i'
	set_7seg_data(0x0d, 0, 2);		// 'd'
	set_7seg_data(0x10, 0, 1);		// '1'
	set_7seg_data(se, 0, 8);		// ݒl

	tim_10ms_sblink = 0;						// _

	while(1){
		uc = get_action_sw();						// XCb`Ԃ
		uc = uc & SWR_MASK;							// EXCb`ɂ

		if(tim_10ms_sblink == 0){				// _Ń^C~O̎
			tim_10ms_sblink = 50;
			if((blk_stat==0)&&((uc & SWR_ON) == 0)){	// ꂢȂ ł̎
				blk_stat = 1;
				set_7seg_data(0x10,0,8);
			}else{
				blk_stat = 0;
				set_7seg_data(se, 0, 8);			// ݒl
			}
		}

		if(uc != 0){								// EANVL鎞
			if((uc & SWR_ON_CONTINUE) != 0){		// ꑱ
				se++;
				if(2 < se){							// Q𒴂
					se = 1;
				}
				set_7seg_data(se, 0, 8);			// ݒl
			}else if((uc & SWR_OFF_SHORT) != 0){	// Zꂽ
				break;
			}
		}
	}
	cli();
	if(bef_se != se){
		eeprom_busy_wait();
		eeprom_write_byte(&eep_disp_mode, se);		// 
		eeprom_busy_wait();
	}
	return(se);
}

#if	1
//***************************
//  Main
//  {
//***************************
int	main(void)
{

	char			uc;
	unsigned char	se;
	int				i;
	unsigned short	bright;
	unsigned char	bef_disp_clock_mode=HMS;
	unsigned char	disp_clock_mode=HMS;
	unsigned char	old_rtc_1s_flg=0xff;
	unsigned char	old_RTC_hou = 0xff;
	unsigned char	old_RTC_min = 0xff;
	unsigned char	old_RTC_mon = 0xff;
	unsigned char	old_RTC_day = 0xff;
	unsigned char	old_RTC_year = 0xff;
	unsigned short	old_AD_data = 0xffff;

	uart_init();										// UART Initial

	uart_tx_str_crlf(" ");								// UART TxD String + CR + LF
	uart_tx_str_crlf(__DATE__);							// UART TxD String + CR + LF
	uart_tx_str_crlf(__TIME__);							// UART TxD String + CR + LF
	uart_tx_str_crlf(__FILE__);							// UART TxD String + CR + LF

	uart_tx_str_crlf("Ecoh Start");						// UART TxD String + CR + LF

// VZO\
	init_7seg();										//  VZOp̏ݒ
	chang_7seg_data(num_data,dp_data);					//  VZOf[^֕ϊX
	set_7seg_enable();									//  VZO\̗L̃Zbg

	sw_init();											//@XCb`̏ݒ
	rtc_init();											//  qsb̏ݒ
	ad1_init();											// A/D 1 Initial
	Timer2_init();										// Timer2 Initial
	led_init();

	eeprom_busy_wait();
	se = eeprom_read_byte(&eep_disp_mode);				// Ǐo
	if(se == 1){										// HMS
		;
	}else if(se != 2){									// ُȒl
		se = 1;
		eeprom_busy_wait();
		eeprom_write_byte(&eep_disp_mode, se);			// 
		eeprom_busy_wait();
	}


	tim_10ms_led = 50;									// kdcpPOrPʃ^C}[
	old_RTC_hou = 0xff;
	old_RTC_min = 0xff;
	old_RTC_mon = 0xff;
	old_RTC_day = 0xff;
	old_RTC_year = 0xff;

	if((PIND & SW_RIGHT) == 0){							// XCb`f[^Ă
		delay_ms(100);									// 100mS Delay
		if((PIND & SW_RIGHT) == 0){
			se = set_pro();								// ݒs
		}
	}

	if(se == 2){
		disp_clock_mode=MDHM;
	}

	sei();												// 荞݉

	while(1){
		if(Get_rxd((unsigned char *)(&uc)) != 0){				// MiGR[obNj
			uart_tx_one(uc);									// UART TxD One Char
		}
		uc = get_action_sw();									// XCb`Ԃ
		uc = uc & 0x0f;											// XCb`ɂ
		if(uc == SWR_OFF_LONG){									// ꂽ
			proc_no_key_timeup(1);								// L[͂L
			bef_disp_clock_mode = disp_clock_mode;
			disp_clock_mode = SET;
			proc_set_rtc();										// v킹
			if((bef_disp_clock_mode == MDHM)||(bef_disp_clock_mode == YEAR)||(bef_disp_clock_mode == A_D_MDHM)){	// \AN\̎
				disp_clock_mode = MDHM;
			}else{
				disp_clock_mode = HMS;
			}
			old_RTC_mon = 0xff;
			old_RTC_day = 0xff;
			old_RTC_hou = 0xff;
			old_RTC_min = 0xff;
			old_rtc_1s_flg = (rtc_1s_flg - 1);
		}else if(uc == SWR_OFF_SHORT){							// Zꂽ
			proc_no_key_timeup(1);								// L[͂L
			switch(disp_clock_mode){							// 샂[hύX
			 case HMS:
				disp_clock_mode = YMD;
				old_RTC_year = 0xff;
				old_RTC_mon = 0xff;
				old_RTC_day = 0xff;
				break;
			 case YMD:
				disp_clock_mode = A_D;
				old_AD_data = 0xffff;
				break;
			 case A_D:
				disp_clock_mode = HMS;
				old_RTC_hou = 0xff;
				old_RTC_min = 0xff;
				break;
			 case MDHM:
				disp_clock_mode = YEAR;
				old_RTC_year = 0xff;
				break;
			 case YEAR:
				disp_clock_mode = A_D_MDHM;
				old_AD_data = 0xffff;
				break;
			 case A_D_MDHM:
				disp_clock_mode = MDHM;
				old_RTC_mon = 0xff;
				old_RTC_day = 0xff;
				old_RTC_hou = 0xff;
				old_RTC_min = 0xff;
				break;
			 default:
				disp_clock_mode = HMS;
				old_RTC_hou = 0xff;
				old_RTC_min = 0xff;
				break;
			}
			old_rtc_1s_flg = (rtc_1s_flg - 1);					// ɕ\
		}else{
			if(rtc_1s_flg != old_rtc_1s_flg){					// qsbĂ鎞̂Pboߗp
				old_rtc_1s_flg = rtc_1s_flg;
				bright = ad1_get_data();						// A/D1i邳j 擾
				if((disp_clock_mode == A_D)||(disp_clock_mode == A_D_MDHM)){	// `cf[^\̎
					if(old_AD_data != bright){					// `^cf[^ω
						for(i=0;i<KETA_MAX;i++){
							num_data[i] = 0x10;					// SuN
						}
						wtod_04bcd(num_data+1, bright);
						chang_7seg_data(num_data,dp_data);		//  VZOf[^֕ϊX
						old_AD_data = bright;
					}
				}else{
					rtc_read();										// RTC ǂݏo
					if(disp_clock_mode == HMS){						// \̎
						if(old_RTC_hou != gRTC_hou){				// ω
							set_7seg_data(gRTC_hou >> 4,0,1);		// \
							set_7seg_data(gRTC_hou & 0x0f,0,2);
							set_7seg_data('-',0,3);
							old_RTC_hou = gRTC_hou;
						}
						if(old_RTC_min != gRTC_min){				// ω
							set_7seg_data(gRTC_min >> 4,0,4);		// \
							set_7seg_data(gRTC_min & 0x0f,0,5);
							set_7seg_data('-',0,6);
							old_RTC_min = gRTC_min;
						}
						set_7seg_data(gRTC_sec >> 4,0,7);			// b\
						set_7seg_data(gRTC_sec & 0x0f,0,8);
						if((gRTC_min == 0)&&(gRTC_sec == 0)){		// ̎
							led_on_off(1);							//  kdĉnm
							bef_disp_clock_mode = disp_clock_mode;
							disp_clock_mode = ANIME;
							disp_animation(1);						// Aj[V
							tim_10ms_led = 50;						// TOOr^C}[d|
						}
					}else if(disp_clock_mode == YMD){				// \̎
						if(old_RTC_year != gRTC_year){				// Nω
							set_7seg_data(gRTC_year >> 4,0,1);		// N\
							set_7seg_data(gRTC_year & 0x0f,0,2);
							set_7seg_data('=',0,3);
							old_RTC_year = gRTC_year;
						}
						if(old_RTC_mon != gRTC_mon){				// ω
							set_7seg_data(gRTC_mon >> 4,0,4);		// \
							set_7seg_data(gRTC_mon & 0x0f,0,5);
							set_7seg_data('=',0,6);
							old_RTC_mon = gRTC_mon;
						}
						if(old_RTC_day != gRTC_day){				// ω
							set_7seg_data(gRTC_day >> 4,0,7);		// \
							set_7seg_data(gRTC_day & 0x0f,0,8);
							old_RTC_day = gRTC_day;
						}
					}else if(disp_clock_mode == MDHM){				// \̎
						if(old_RTC_mon != gRTC_mon){				// ω
							set_7seg_data(gRTC_mon >> 4,0,1);		// \
							set_7seg_data(gRTC_mon & 0x0f,0,2);
							old_RTC_mon = gRTC_mon;
							set_7seg_dp(1, 2);						// _ nm
						}
						if(old_RTC_day != gRTC_day){				// ω
							set_7seg_data(gRTC_day >> 4,0,3);		// \
							set_7seg_data(gRTC_day & 0x0f,0,4);
							old_RTC_day = gRTC_day;
							set_7seg_dp(1, 4);						// _ nm
						}
						if(old_RTC_hou != gRTC_hou){				// ω
							set_7seg_data(gRTC_hou >> 4,0,5);		// \
							set_7seg_data(gRTC_hou & 0x0f,0,6);
							old_RTC_hou = gRTC_hou;
							set_7seg_dp(1, 6);						// _ nm
						}
						if(old_RTC_min != gRTC_min){				// ω
							set_7seg_data(gRTC_min >> 4,0,7);		// \
							set_7seg_data(gRTC_min & 0x0f,0,8);
							old_RTC_min = gRTC_min;
						}
						if((gRTC_min == 0)&&(gRTC_sec == 0)){		// ̎
							led_on_off(1);							//  kdcR̂nm
							bef_disp_clock_mode = disp_clock_mode;
							disp_clock_mode = ANIME;
							disp_animation(1);						// Aj[V
							tim_10ms_led = 50;						// TOOr^C}[d|
						}
						set_7seg_dp(1, 0);							// _ nm
						tim_10ms_led = 50;							// TOOr^C}[d|
					}else if(disp_clock_mode == YEAR){				// N\̎
						if(old_RTC_year != gRTC_year){				// Nω
							set_7seg_data(0x10,0,1);
							set_7seg_data(0x10,0,2);
							set_7seg_data(0x10,0,3);
							set_7seg_data(0x10,0,4);
							set_7seg_data(2,0,5);
							set_7seg_data(0,0,6);
							set_7seg_data(gRTC_year >> 4,0,7);		// N\
							set_7seg_data(gRTC_year & 0x0f,0,8);
							old_RTC_year = gRTC_year;
							set_7seg_dp(0, 0);						// _ nee
						}
					}
				}

				if (proc_no_key_timeup(0) == 0xff){				// ԃL[͂
					if((disp_clock_mode != HMS)&&(disp_clock_mode != ANIME)&&(disp_clock_mode != MDHM)){	// \łA\łAAjł
						if((disp_clock_mode == YEAR)||(disp_clock_mode == A_D_MDHM)){
							disp_clock_mode = MDHM;
						}else{
							disp_clock_mode = HMS;
						}
						old_RTC_mon = 0xff;
						old_RTC_day = 0xff;
						old_RTC_hou = 0xff;
						old_RTC_min = 0xff;
					}
				}

				if(bright < 500){								// ͂邢
					set_7seg_bright(2);							// VZO\̖邳ݒiԖ邢j
				}else if(bright < 600){							// ͂炢
					set_7seg_bright(1);							// VZO\̖邳ݒi炢j
				}else{											// ͂Â
					set_7seg_bright(0);							// VZO\̖邳ݒiԈÂj
				}
			}
		}

		if(tim_10ms_led == 0){									// TOOro߂
			if (disp_clock_mode == MDHM){						// \̎
				set_7seg_dp(0, 0);								// _ nee
			}else if (disp_clock_mode == ANIME){				// Aj[V̎ɂTOOro߂
				tim_10ms_led = 50;								// TOOr^C}[d|
				if(disp_animation(0) == 1){						// \
					disp_clock_mode = bef_disp_clock_mode;		// I͌̕\ɂ
					led_on_off(0);								// kdĉnee
				}
				old_RTC_mon = 0xff;
				old_RTC_day = 0xff;
				old_RTC_hou = 0xff;
				old_RTC_min = 0xff;
			}
		}

		sleep_mode();											// X[vڍs
	}
}
#else
//***************************
//  Main
//	`FbNp
//***************************
int	main(void)
{

	char			uc;
	char			ddp;

// VZO\
	init_7seg();										//  VZOp̏ݒ
	num_data[0] = '-';
	chang_7seg_data(num_data,dp_data);					//  VZOf[^֕ϊX

	sw_init();											//@XCb`̏ݒ
	rtc_init();											//  qsb̏ݒ
	ad1_init();											// A/D 1 Initial
	Timer2_init();										// Timer2 Initial
	led_init();											// LED̏ݒ

	tim_10ms_led = 50;									// kdcpPOrPʃ^C}[
	sei();												// 荞݉

	uc = 0;
	ddp = 0;
	chk_disp_7seg(uc, ddp, uc);
	led_on_off(uc & 1);
	uc++;
	ddp = ((uc/KETA_MAX) & 1);
	uc %= KETA_MAX;
	while(1){
		delay_ms(1000);
//		delay_ms(1);
		chk_disp_7seg(uc, ddp, uc);
		led_on_off(uc & 1);
		uc++;
		uc %= KETA_MAX;
		if(uc == 0){
			ddp ^= 1;
			if(ddp == 0){
				break;
			}
		}
	}

//	for(uc=0;uc<KETA_MAX;uc++){
//		num_data[uc]= 0x10;								// SuN
//		dp_data[uc]=0;									// SȂ
//	}
//	num_data[1]= 1;										// No1='1'
	
	chang_7seg_data(num_data,dp_data);					//  VZOf[^֕ϊX
	set_7seg_enable();									//  VZO_Ci~bN\̗L̃Zbg

	while(1){
		delay_ms(1000);
//		delay_ms(1);
		set_7seg_dp(0, uc);
		led_on_off(uc & 1);
		uc++;
		uc %= KETA_MAX;
		set_7seg_dp(1, uc);
	}
}
#endif
