//*****************************************
// IV-18 VFD Clock Program Mega328
// CPU Clock:8MHz
//   iq[Yf[^@UWlgɂj
// File Name:set_rtc.c
//
//
//  2016/04/26 New  Taishi  vݒ蕔 Rtc_DS3234.c 番
//*****************************************

#include	"iv18_clock.h"
#include	"Timer.h"
#include	"disp_7seg_iv18.h"
#include	"port_bit.h"
#include	"Rtc_DS3234.h"

#include	"set_rtc.h"

//*****************************************
// N킹
// ߂l@OFɂqsbɃANZXł
// @@@@PFɂqsbɃANZXłȂ
// @OFԑ얳
//*****************************************
static unsigned char	proc_set_year(void)
{
	unsigned char	blk_stat=0;
	unsigned char	ye;
	unsigned char	ucr;
	unsigned char	r=0;

	ye = gRTC_year;
	set_7seg_data(ye >> 4,0,1);
	set_7seg_data(ye & 0x0f,0,2);
	set_7seg_data('=',0,3);
	set_7seg_data(gRTC_mon >> 4,0,4);		// \
	set_7seg_data(gRTC_mon & 0x0f,0,5);
	set_7seg_data('=',0,6);
	set_7seg_data(gRTC_day >> 4,0,7);
	set_7seg_data(gRTC_day & 0x0f,0,8);

	tim_10ms_sblink = 0;						// _
	while(1){
		ucr = get_action_sw();					// XCb`Ԃ
		ucr = ucr & SWR_MASK;					// EXCb`ɂ

		if(tim_10ms_sblink == 0){				// _Ń^C~O̎
			tim_10ms_sblink = 50;
			if((blk_stat==0)&&((ucr & SWR_ON) == 0)){	// ꂢȂ ł̎
				blk_stat = 1;
				set_7seg_data(16,0,1);
				set_7seg_data(16,0,2);
			}else{
				blk_stat = 0;
				set_7seg_data(ye >> 4,0,1);
				set_7seg_data(ye & 0x0f,0,2);
			}
		}

		if(ucr != 0){							// EANVL鎞
			proc_no_key_timeup(1);				// L[͂L
			if((ucr & SWR_ON_CONTINUE) != 0){	// ꑱ
				ye++;
				if(9 < (ye & 0x0f)){			// X𒴂
					ye &= 0xf0;
					ye += 0x10;
				}
				if(0x99 < ye){
					ye = 0;
				}
			}else if((ucr & SWR_OFF_SHORT) != 0){	// Zꂽ
				if(gRTC_year == ye){			// lύXĂȂ
					r = 0;
				}else{
					gRTC_year = ye;
					rtc_write();				// RTC 
				}
				break;
			}
		}

		if (proc_no_key_timeup(0) == 0xff){		// ԃL[͂
			r = 0xff;
			break;
		}
	}

	return(r);
}
//*****************************************
// 킹
// ߂l@OFɂqsbɃANZXł
// @@@@PFɂqsbɃANZXłȂ
// @OFԑ얳
//*****************************************
static unsigned char	proc_set_month(void)
{
	unsigned char	blk_stat=0;
	unsigned char	mo;
	unsigned char	ucr;
	unsigned char	r=0;

	mo = gRTC_mon;
	set_7seg_data(gRTC_year >> 4,0,1);		// N\
	set_7seg_data(gRTC_year & 0x0f,0,2);
	set_7seg_data(mo >> 4,0,4);
	set_7seg_data(mo & 0x0f,0,5);
	set_7seg_data(gRTC_day >> 4,0,7);
	set_7seg_data(gRTC_day & 0x0f,0,8);

	tim_10ms_sblink = 0;						// _
	while(1){
		ucr = get_action_sw();					// XCb`Ԃ
		ucr = ucr & SWR_MASK;					// EXCb`ɂ

		if(tim_10ms_sblink == 0){				// _Ń^C~O̎
			tim_10ms_sblink = 50;
			if((blk_stat==0)&&((ucr & SWR_ON) == 0)){	// ꂢȂ ł̎
				blk_stat = 1;
				set_7seg_data(16,0,4);
				set_7seg_data(16,0,5);
			}else{
				blk_stat = 0;
				set_7seg_data(mo >> 4,0,4);
				set_7seg_data(mo & 0x0f,0,5);
			}
		}

		if(ucr != 0){							// EANVL鎞
			proc_no_key_timeup(1);				// L[͂L
			if((ucr & SWR_ON_CONTINUE) != 0){	// ꑱ
				mo++;
				if(9 < (mo & 0x0f)){			// X𒴂
					mo &= 0xf0;
					mo += 0x10;
				}
				if(0x12 < mo){
					mo = 1;
				}
			}else if((ucr & SWR_OFF_SHORT) != 0){	// Zꂽ
				if(gRTC_mon == mo){				// lύXĂȂ
					r = 0;
				}else{
					gRTC_mon = mo;
					rtc_write();				// RTC 
				}
				break;
			}
		}

		if (proc_no_key_timeup(0) == 0xff){		// ԃL[͂
			r = 0xff;
			break;
		}
	}

	return(r);
}
//*****************************************
// 킹
// ߂l@OFɂqsbɃANZXł
// @@@@PFɂqsbɃANZXłȂ
// @OFԑ얳
//*****************************************
static unsigned char	proc_set_day(void)
{
	unsigned char	blk_stat=0;
	unsigned char	da;
	unsigned char	ucr;
	unsigned char	r=0;
	unsigned char	uru=0;
	unsigned char	syo=0;

	if(((((gRTC_year/16)*10)+(gRTC_year/16))/4) == 0){									// 邤N
		uru=1;
	}
	if((gRTC_mon == 0x04)||(gRTC_mon == 0x06)||(gRTC_mon == 0x09)||(gRTC_mon == 0x11)){	// ̌
		syo=1;
	}
	da = gRTC_day;
	set_7seg_data(gRTC_year >> 4,0,1);		// N\
	set_7seg_data(gRTC_year & 0x0f,0,2);
	set_7seg_data(gRTC_mon >> 4,0,4);
	set_7seg_data(gRTC_mon & 0x0f,0,5);
	set_7seg_data(da >> 4,0,7);
	set_7seg_data(da & 0x0f,0,8);


	tim_10ms_sblink = 0;						// _
	while(1){
		ucr = get_action_sw();					// XCb`Ԃ
		ucr = ucr & SWR_MASK;					// EXCb`ɂ

		if(tim_10ms_sblink == 0){				// _Ń^C~O̎
			tim_10ms_sblink = 50;
			if((blk_stat==0)&&((ucr & SWR_ON) == 0)){	// ꂢȂ ł̎
				blk_stat = 1;
				set_7seg_data(16,0,7);
				set_7seg_data(16,0,8);
			}else{
				blk_stat = 0;
				set_7seg_data(da >> 4,0,7);
				set_7seg_data(da & 0x0f,0,8);
			}
		}

		if(ucr != 0){							// EANVL鎞
			proc_no_key_timeup(1);				// L[͂L
			if((ucr & SWR_ON_CONTINUE) != 0){	// ꑱ
				da++;
				if(9 < (da & 0x0f)){			// X𒴂
					da &= 0xf0;
					da += 0x10;
				}
				if(syo == 1){					// ̌
					if(0x30 < da){
						da = 1;
					}
				}else if(gRTC_mon == 0x02){
					if(uru == 1){				// Q 邤N
						if(0x29 < da){
							da = 1;
						}
					}else{						// Q N
						if(0x28 < da){
							da = 1;
						}
					}
				}else{							// ̌
					if(0x31 < da){
						da = 1;
					}
				}
			}else if((ucr & SWR_OFF_SHORT) != 0){	// Zꂽ
				if(gRTC_day == da){				// lύXĂȂ
					r = 0;
				}else{
					gRTC_day = da;
					rtc_write();				// RTC 
				}
				break;							// I
			}
		}

		if (proc_no_key_timeup(0) == 0xff){		// ԃL[͂
			r = 0xff;
			break;
		}
	}

	return(r);
}
//*****************************************
// 킹
// ߂l@OFɂqsbɃANZXł
// @@@@PFɂqsbɃANZXłȂ
// @OFԑ얳
//*****************************************
static unsigned char	proc_set_hour(void)
{
	unsigned char	blk_stat=0;
	unsigned char	ho;
	unsigned char	ucr;
	unsigned char	r=0;

	ho = gRTC_hou;
	set_7seg_data(ho >> 4,0,1);
	set_7seg_data(ho & 0x0f,0,2);
	set_7seg_data('-',0,3);
	set_7seg_data(gRTC_min >> 4,0,4);
	set_7seg_data(gRTC_min & 0x0f,0,5);
	set_7seg_data('-',0,6);
	set_7seg_data(gRTC_sec >> 4,0,7);		// b\
	set_7seg_data(gRTC_sec & 0x0f,0,8);

	tim_10ms_sblink = 0;						// _
	while(1){
		ucr = get_action_sw();					// XCb`Ԃ
		ucr = ucr & SWR_MASK;					// EXCb`ɂ

		if(tim_10ms_sblink == 0){				// _Ń^C~O̎
			tim_10ms_sblink = 50;
			if((blk_stat==0)&&((ucr & SWR_ON) == 0)){	// ꂢȂ ł̎
				blk_stat = 1;
				set_7seg_data(16,0,1);
				set_7seg_data(16,0,2);
			}else{
				blk_stat = 0;
				set_7seg_data(ho >> 4,0,1);
				set_7seg_data(ho & 0x0f,0,2);
			}
		}

		if(ucr != 0){							// EANVL鎞
			proc_no_key_timeup(1);				// L[͂L
			if((ucr & SWR_ON_CONTINUE) != 0){	// ꑱ
				ho++;
				if(9 < (ho & 0x0f)){			// X𒴂
					ho &= 0xf0;
					ho += 0x10;
				}
				if(0x23 < ho){
					ho = 0;
				}
			}else if((ucr & SWR_OFF_SHORT) != 0){	// Zꂽ
				if(gRTC_hou == ho){				// lύXĂȂ
					r = 0;
				}else{
					gRTC_hou = ho;
					rtc_write();				// RTC 
				}
				break;
			}
		}

		if (proc_no_key_timeup(0) == 0xff){		// ԃL[͂
			r = 0xff;
			break;
		}
	}

	return(r);
}
//*****************************************
// 킹
// ߂l@OFɂqsbɃANZXł
// @@@@PFɂqsbɃANZXłȂ
// @OFԑ얳
//*****************************************
static unsigned char	proc_set_minute(void)
{
	unsigned char	blk_stat=0;
	unsigned char	mi;
	unsigned char	ucr;
	unsigned char	r=0;

	mi = gRTC_min;
	set_7seg_data(gRTC_hou >> 4,0,1);
	set_7seg_data(gRTC_hou & 0x0f,0,2);
	set_7seg_data(mi >> 4,0,4);
	set_7seg_data(mi & 0x0f,0,5);
	set_7seg_data(gRTC_sec >> 4,0,7);		// b\
	set_7seg_data(gRTC_sec & 0x0f,0,8);

	tim_10ms_sblink = 0;						// _
	while(1){
		ucr = get_action_sw();					// XCb`Ԃ
		ucr = ucr & SWR_MASK;					// EXCb`ɂ

		if(tim_10ms_sblink == 0){				// _Ń^C~O̎
			tim_10ms_sblink = 50;
			if((blk_stat==0)&&((ucr & SWR_ON) == 0)){	// ꂢȂ ł̎
				blk_stat = 1;
				set_7seg_data(16,0,4);
				set_7seg_data(16,0,5);
			}else{
				blk_stat = 0;
				set_7seg_data(mi >> 4,0,4);
				set_7seg_data(mi & 0x0f,0,5);
			}
		}

		if(ucr != 0){							// EANVL鎞
			proc_no_key_timeup(1);				// L[͂L
			if((ucr & SWR_ON_CONTINUE) != 0){	// ꑱ
				mi++;
				if(9 < (mi & 0x0f)){			// X𒴂
					mi &= 0xf0;
					mi += 0x10;
				}
				if(0x59 < mi){
					mi = 0;
				}
			}else if((ucr & SWR_OFF_SHORT) != 0){	// Zꂽ
				if(gRTC_min == mi){				// lύXĂȂ
					r = 0;
				}else{
					gRTC_min = mi;
					rtc_write();				// RTC 
				}
				break;
			}
		}

		if (proc_no_key_timeup(0) == 0xff){		// ԃL[͂
			r = 0xff;
			break;
		}
	}

	return(r);
}
//*****************************************
// b킹
// ߂l@OFɂqsbɃANZXł
// @@@@PFɂqsbɃANZXłȂ
// @OFԑ얳
//*****************************************
static unsigned char	proc_set_sec(void)
{
	unsigned char	blk_stat=0;
	unsigned char	se;
	unsigned char	ucr;
	unsigned char	r=0;

	se = gRTC_sec;
	set_7seg_data(gRTC_hou >> 4,0,1);
	set_7seg_data(gRTC_hou & 0x0f,0,2);
	set_7seg_data(gRTC_min >> 4,0,4);
	set_7seg_data(gRTC_min & 0x0f,0,5);
	set_7seg_data(se >> 4,0,7);		// b\
	set_7seg_data(se & 0x0f,0,8);

	tim_10ms_sblink = 0;						// _
	while(1){
		ucr = get_action_sw();					// XCb`Ԃ
		ucr = ucr & SWR_MASK;					// EXCb`ɂ

		if(tim_10ms_sblink == 0){				// _Ń^C~O̎
			tim_10ms_sblink = 50;
			if((blk_stat==0)&&((ucr & SWR_ON) == 0)){	// ꂢȂ ł̎
				blk_stat = 1;
				set_7seg_data(16,0,7);
				set_7seg_data(16,0,8);
			}else{
				blk_stat = 0;
				set_7seg_data(se >> 4,0,7);
				set_7seg_data(se & 0x0f,0,8);
			}
		}

		if(ucr != 0){							// EANVL鎞
			proc_no_key_timeup(1);				// L[͂L
			if((ucr & SWR_ON_CONTINUE) != 0){	// ꑱ
				se++;
				if(9 < (se & 0x0f)){			// X𒴂
					se &= 0xf0;
					se += 0x10;
				}
				if(0x59 < se){
					se = 0;
				}
			}else if((ucr & SWR_OFF_SHORT) != 0){	// Zꂽ
				if(gRTC_sec == se){				// lύXĂȂ
					r = 0;
				}else{
					gRTC_sec = se;
					rtc_write();				// RTC 
				}
				break;
			}
		}

		if (proc_no_key_timeup(0) == 0xff){		// ԃL[͂
			r = 0xff;
			break;
		}
	}

	return(r);
}
//*****************************************
// v킹
// ߂l@OFɂqsbɃANZXł
// @@@@PFɂqsbɃANZXłȂ
// @OFԑ얳
//*****************************************
unsigned char	proc_set_rtc(void)
{
	unsigned char	r;

	rtc_read();									// RTC ǂݏo

	gRTC_mon &= 0x1f;							// 
	gRTC_day &= 0x3f;							// 
	gRTC_hou &= 0x3f;							// 
	gRTC_min &= 0x7f;							// 
	gRTC_sec &= 0x7f;							// b

	r = proc_set_year();						// N킹
	if(r == 0){
		r = proc_set_month();					// 킹
		if(r == 0){
			r = proc_set_day();					// 킹
			if(r == 0){
				r = proc_set_hour();			// 킹
				if(r == 0){
					r = proc_set_minute();		// 킹
					if(r == 0){
						r = proc_set_sec();		// b킹
					}
				}
			}
		}
	}
	return(r);
}

